/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.138 Revision 1.163
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.138 2010/03/15 19:05:51 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.163 2011/08/21 16:14:56 jmbsvicetto Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
59# Upstream MySQL considers the first two parts of the version number to be the 59# Upstream MySQL considers the first two parts of the version number to be the
60# major version. Upgrades that change major version should always run 60# major version. Upgrades that change major version should always run
61# mysql_upgrade. 61# mysql_upgrade.
62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})" 62MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
63 63
64# Cluster is a special case...
65if [[ "${PN}" == "mysql-cluster" ]]; then
66 case $PV in
67 6.1*|7.0*|7.1*) MYSQL_PV_MAJOR=5.1 ;;
68 esac
69fi
70
71
64# @ECLASS-VARIABLE: MYSQL_VERSION_ID 72# @ECLASS-VARIABLE: MYSQL_VERSION_ID
65# @DESCRIPTION: 73# @DESCRIPTION:
66# MYSQL_VERSION_ID will be: 74# MYSQL_VERSION_ID will be:
67# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 75# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
68# This is an important part, because many of the choices the MySQL ebuild will do 76# This is an important part, because many of the choices the MySQL ebuild will do
95 MYSQL_COMMUNITY_FEATURES=1 103 MYSQL_COMMUNITY_FEATURES=1
96elif [ "${PV#5.4}" != "${PV}" ] ; then 104elif [ "${PV#5.4}" != "${PV}" ] ; then
97 MYSQL_COMMUNITY_FEATURES=1 105 MYSQL_COMMUNITY_FEATURES=1
98elif [ "${PV#5.5}" != "${PV}" ] ; then 106elif [ "${PV#5.5}" != "${PV}" ] ; then
99 MYSQL_COMMUNITY_FEATURES=1 107 MYSQL_COMMUNITY_FEATURES=1
100elif [ "${PV#6.0}" != "${PV}" ] ; then 108elif [ "${PV#6}" != "${PV}" ] ; then
109 MYSQL_COMMUNITY_FEATURES=1
110elif [ "${PV#7}" != "${PV}" ] ; then
101 MYSQL_COMMUNITY_FEATURES=1 111 MYSQL_COMMUNITY_FEATURES=1
102else 112else
103 MYSQL_COMMUNITY_FEATURES=0 113 MYSQL_COMMUNITY_FEATURES=0
104fi 114fi
105 115
124 134
125[[ "${PN}" == "mariadb" ]] \ 135[[ "${PN}" == "mariadb" ]] \
126&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )" 136&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
127 137
128# Having different flavours at the same time is not a good idea 138# Having different flavours at the same time is not a good idea
129for i in "mysql" "mysql-community" "mariadb" ; do 139for i in "mysql" "mysql-community" "mysql-cluster" "mariadb" ; do
130 [[ "${i}" == ${PN} ]] || 140 [[ "${i}" == ${PN} ]] ||
131 DEPEND="${DEPEND} !dev-db/${i}" 141 DEPEND="${DEPEND} !dev-db/${i}"
132done 142done
133 143
134RDEPEND="${DEPEND} 144RDEPEND="${DEPEND}
135 !minimal? ( dev-db/mysql-init-scripts ) 145 !minimal? ( dev-db/mysql-init-scripts )
136 selinux? ( sec-policy/selinux-mysql )" 146 selinux? ( sec-policy/selinux-mysql )"
137 147
148DEPEND="${DEPEND}
149 virtual/yacc"
150
151if [ "${EAPI:-0}" = "2" ]; then
152 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
153fi
154
138# compile-time-only 155# compile-time-only
139mysql_version_is_at_least "5.1" \ 156mysql_version_is_at_least "5.1" \
140|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 157|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
141 158
142# compile-time-only 159# compile-time-only
143mysql_version_is_at_least "5.1.12" \ 160mysql_version_is_at_least "5.1.12" \
144&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 161&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
162
163[[ "${PN}" == "mariadb" ]] \
164&& mysql_version_is_at_least "5.2" \
165&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
166#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
167# sphinx? ( app-misc/sphinx )"
145 168
146# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 169# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
147PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 170PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
148 171
149# For other stuff to bring us in 172# For other stuff to bring us in
152# Work out the default SERVER_URI correctly 175# Work out the default SERVER_URI correctly
153if [ -z "${SERVER_URI}" ]; then 176if [ -z "${SERVER_URI}" ]; then
154 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}" 177 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
155 if [ "${PN}" == "mariadb" ]; then 178 if [ "${PN}" == "mariadb" ]; then
156 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})" 179 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
180 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
181 SERVER_URI="
182 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
183 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
184 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
157 SERVER_URI="http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/mariadb-${MARIA_FULL_PV}.tar.gz" 185 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
186 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
187 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
188 "
158 # The community build is on the mirrors 189 # The community and cluster builds are on the mirrors
159 elif [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 190 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
160 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz" 191 if [[ "${PN}" == "mysql-cluster" ]] ; then
192 URI_DIR="MySQL-Cluster"
193 URI_FILE="mysql-cluster-gpl"
194 else
195 URI_DIR="MySQL"
196 URI_FILE="mysql"
197 fi
198 URI_A="${URI_FILE}-${MY_PV}.tar.gz"
199 MIRROR_PV=$(get_version_component_range 1-2 ${PV})
200 # Recently upstream switched to an archive site, and not on mirrors
201 SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}
202 mirror://mysql/Downloads/${URI_DIR}-${PV%.*}/${URI_A}"
161 # The (old) enterprise source is on the primary site only 203 # The (old) enterprise source is on the primary site only
162 elif [ "${PN}" == "mysql" ]; then 204 elif [ "${PN}" == "mysql" ]; then
163 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz" 205 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
164 fi 206 fi
165fi 207fi
178HOMEPAGE="http://www.mysql.com/" 220HOMEPAGE="http://www.mysql.com/"
179if [[ "${PN}" == "mariadb" ]]; then 221if [[ "${PN}" == "mariadb" ]]; then
180 HOMEPAGE="http://askmonty.org/" 222 HOMEPAGE="http://askmonty.org/"
181 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged." 223 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
182fi 224fi
225if [[ "${PN}" == "mysql-community" ]]; then
226 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
227fi
183LICENSE="GPL-2" 228LICENSE="GPL-2"
184SLOT="0" 229SLOT="0"
185IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test" 230IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
186 231
187mysql_version_is_at_least "4.1" \ 232mysql_version_is_at_least "4.1" \
188&& IUSE="${IUSE} latin1" 233&& IUSE="${IUSE} latin1"
189 234
190mysql_version_is_at_least "4.1.3" \ 235if mysql_version_is_at_least "4.1.3" ; then
191&& IUSE="${IUSE} cluster extraengine" 236 IUSE="${IUSE} extraengine"
237 if [[ "${PN}" != "mysql-cluster" ]] ; then
238 IUSE="${IUSE} cluster"
239 fi
240fi
192 241
193mysql_version_is_at_least "5.0" \ 242mysql_version_is_at_least "5.0" \
194|| IUSE="${IUSE} raid" 243|| IUSE="${IUSE} raid"
195 244
196mysql_version_is_at_least "5.0.18" \ 245mysql_version_is_at_least "5.0.18" \
202[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 251[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
203&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 252&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
204 253
205[[ "${PN}" == "mariadb" ]] \ 254[[ "${PN}" == "mariadb" ]] \
206&& IUSE="${IUSE} libevent" 255&& IUSE="${IUSE} libevent"
256
257[[ "${PN}" == "mariadb" ]] \
258&& mysql_version_is_at_least "5.2" \
259&& IUSE="${IUSE} oqgraph"
260#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
261#&& IUSE="${IUSE} oqgraph sphinx"
207 262
208# MariaDB has integrated PBXT 263# MariaDB has integrated PBXT
209# PBXT_VERSION means that we have a PBXT patch for this PV 264# PBXT_VERSION means that we have a PBXT patch for this PV
210# PBXT was only introduced after 5.1.12 265# PBXT was only introduced after 5.1.12
211pbxt_patch_available() { 266pbxt_patch_available() {
229 && mysql_version_is_at_least "5.1.26" \ 284 && mysql_version_is_at_least "5.1.26" \
230 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] 285 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
231 return $? 286 return $?
232} 287}
233 288
289
234pbxt_patch_available \ 290pbxt_patch_available \
235&& PBXT_P="pbxt-${PBXT_VERSION}" \ 291&& PBXT_P="pbxt-${PBXT_VERSION}" \
236&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \ 292&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
237&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \ 293&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
238 294
295# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
296# vs. built outside the dir
239pbxt_available \ 297pbxt_available \
240&& IUSE="${IUSE} pbxt" 298&& IUSE="${IUSE} pbxt" \
299&& mysql_version_is_at_least "5.1.40" \
300&& PBXT_NEWSTYLE=1
241 301
242xtradb_patch_available \ 302xtradb_patch_available \
243&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \ 303&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
244&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \ 304&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
245&& XTRADB_SRC_URI1="http://www.percona.com/percona-builds/xtradb/${XTRADB_SRC_URI_COMMON}" \ 305&& XTRADB_SRC_B1="http://www.percona.com/" \
306&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
307&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
246&& XTRADB_SRC_URI2="http://www.percona.com/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \ 308&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
309&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
247&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} )" \ 310&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
248&& IUSE="${IUSE} xtradb" 311&& IUSE="${IUSE} xtradb"
249 312
250# 313#
251# HELPER FUNCTIONS: 314# HELPER FUNCTIONS:
252# 315#
257mysql_disable_test() { 320mysql_disable_test() {
258 local rawtestname testname testsuite reason mysql_disable_file 321 local rawtestname testname testsuite reason mysql_disable_file
259 rawtestname="${1}" ; shift 322 rawtestname="${1}" ; shift
260 reason="${@}" 323 reason="${@}"
261 ewarn "test '${rawtestname}' disabled: '${reason}'" 324 ewarn "test '${rawtestname}' disabled: '${reason}'"
262 325
263 testsuite="${rawtestname/.*}" 326 testsuite="${rawtestname/.*}"
264 testname="${rawtestname/*.}" 327 testname="${rawtestname/*.}"
265 mysql_disable_file="${S}/mysql-test/t/disabled.def" 328 mysql_disable_file="${S}/mysql-test/t/disabled.def"
266 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}" 329 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
267 echo ${testname} : ${reason} >> "${mysql_disable_file}" 330 echo ${testname} : ${reason} >> "${mysql_disable_file}"
349 MY_DATADIR="${new_MY_DATADIR}" 412 MY_DATADIR="${new_MY_DATADIR}"
350 fi 413 fi
351 fi 414 fi
352 fi 415 fi
353 416
417 if [ "${MY_SOURCEDIR:-unset}" == "unset" ]; then
354 MY_SOURCEDIR=${SERVER_URI##*/} 418 MY_SOURCEDIR=${SERVER_URI##*/}
355 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 419 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
420 fi
356 421
357 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 422 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
358 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 423 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
359 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR 424 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
360} 425}
407 if use debug ; then 472 if use debug ; then
408 myconf="${myconf} --with-debug=full" 473 myconf="${myconf} --with-debug=full"
409 else 474 else
410 myconf="${myconf} --without-debug" 475 myconf="${myconf} --without-debug"
411 mysql_version_is_at_least "4.1.3" \ 476 mysql_version_is_at_least "4.1.3" \
412 && use cluster \ 477 && ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) \
413 && myconf="${myconf} --without-ndb-debug" 478 && myconf="${myconf} --without-ndb-debug"
414 fi 479 fi
415 480
416 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then 481 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
417 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}" 482 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
474 myconf="${myconf} --without-berkeley-db" 539 myconf="${myconf} --without-berkeley-db"
475 fi 540 fi
476 541
477 if mysql_version_is_at_least "4.1.3" ; then 542 if mysql_version_is_at_least "4.1.3" ; then
478 myconf="${myconf} --with-geometry" 543 myconf="${myconf} --with-geometry"
544 if [[ "${PN}" != "mysql-cluster" ]] ; then
479 myconf="${myconf} $(use_with cluster ndbcluster)" 545 myconf="${myconf} $(use_with cluster ndbcluster)"
546 fi
480 fi 547 fi
481 548
482 if mysql_version_is_at_least "4.1.3" && use extraengine ; then 549 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
483 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 550 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
484 myconf="${myconf} --with-archive-storage-engine" 551 myconf="${myconf} --with-archive-storage-engine"
521 myconf="${myconf} --enable-assembler" 588 myconf="${myconf} --enable-assembler"
522 myconf="${myconf} --with-geometry" 589 myconf="${myconf} --with-geometry"
523 myconf="${myconf} --with-readline" 590 myconf="${myconf} --with-readline"
524 myconf="${myconf} --with-zlib-dir=/usr/" 591 myconf="${myconf} --with-zlib-dir=/usr/"
525 myconf="${myconf} --without-pstack" 592 myconf="${myconf} --without-pstack"
593 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
594
595 # This is an explict die here, because if we just forcibly disable it, then the
596 # user's data is not accessible.
597 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
526 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 598 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
527 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 599 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
528 myconf="${myconf} $(use_enable community community-features)" 600 myconf="${myconf} $(use_enable community community-features)"
529 if use community; then 601 if use community; then
530 myconf="${myconf} $(use_enable profiling)" 602 myconf="${myconf} $(use_enable profiling)"
531 else 603 else
532 myconf="${myconf} --disable-profiling" 604 myconf="${myconf} --disable-profiling"
533 fi 605 fi
534 fi 606 fi
535 607
608 # Scan for all available plugins
609 local plugins_avail="$(
610 LANG=C \
611 find "${S}" \
612 \( \
613 -name 'plug.in' \
614 -o -iname 'configure.in' \
615 -o -iname 'configure.ac' \
616 \) \
617 -print0 \
618 | xargs -0 sed -r -n \
619 -e '/^MYSQL_STORAGE_ENGINE/{
620 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
621 s~^([^ ]+).*~\1~gp;
622 }' \
623 | tr -s '\n' ' '
624 )"
625
536 # 5.1 introduces a new way to manage storage engines (plugins) 626 # 5.1 introduces a new way to manage storage engines (plugins)
537 # like configuration=none 627 # like configuration=none
628 # This base set are required, and will always be statically built.
538 local plugins="csv,myisam,myisammrg,heap" 629 local plugins_sta="csv myisam myisammrg heap"
630 local plugins_dyn=""
631 local plugins_dis="example ibmdb2i"
632
633 # These aren't actually required by the base set, but are really useful:
634 plugins_sta="${plugins_sta} archive blackhole"
635
636 # default in 5.5.4
637 if mysql_version_is_at_least "5.5.4" ; then
638 plugins_sta="${plugins_sta} partition"
639 fi
640 # Now the extras
539 if use extraengine ; then 641 if use extraengine ; then
540 # like configuration=max-no-ndb, archive and example removed in 5.1.11 642 # like configuration=max-no-ndb, archive and example removed in 5.1.11
541 # not added yet: ibmdb2i 643 # not added yet: ibmdb2i
542 # Not supporting as examples: example,daemon_example,ftexample 644 # Not supporting as examples: example,daemon_example,ftexample
543 plugins="${plugins},archive,blackhole,federated,partition" 645 plugins_sta="${plugins_sta} partition"
544 646
545 if [[ "${PN}" != "mariadb" ]] ; then 647 if [[ "${PN}" != "mariadb" ]] ; then
546 elog "Before using the Federated storage engine, please be sure to read" 648 elog "Before using the Federated storage engine, please be sure to read"
547 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 649 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
650 plugins_dyn="${plugins_sta} federated"
548 else 651 else
549 elog "MariaDB includes the FederatedX engine. Be sure to read" 652 elog "MariaDB includes the FederatedX engine. Be sure to read"
550 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine" 653 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
654 plugins_dyn="${plugins_sta} federatedx"
551 fi 655 fi
656 else
657 plugins_dis="${plugins_dis} partition federated"
552 fi 658 fi
553 659
554 # Upstream specifically requests that InnoDB always be built: 660 # Upstream specifically requests that InnoDB always be built:
555 # - innobase, innodb_plugin 661 # - innobase, innodb_plugin
556 # Build falcon if available for 6.x series. 662 # Build falcon if available for 6.x series.
557 for i in innobase innodb_plugin falcon ; do 663 for i in innobase falcon ; do
558 [ -e "${S}"/storage/${i} ] && plugins="${plugins},${i}" 664 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
559 done 665 done
666 for i in innodb_plugin ; do
667 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
668 done
560 669
561 # like configuration=max-no-ndb 670 # like configuration=max-no-ndb
562 if use cluster ; then 671 if ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) ; then
563 plugins="${plugins},ndbcluster" 672 plugins_sta="${plugins_sta} ndbcluster partition"
673 plugins_dis="${plugins_dis//partition}"
564 myconf="${myconf} --with-ndb-binlog" 674 myconf="${myconf} --with-ndb-binlog"
675 else
676 plugins_dis="${plugins_dis} ndbcluster"
565 fi 677 fi
566 678
567 if [[ "${PN}" == "mariadb" ]] ; then 679 if [[ "${PN}" == "mariadb" ]] ; then
568 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not 680 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
569 # caught above. 681 # caught above.
570 plugins="${plugins},maria,innobase"
571 if use pbxt ; then
572 plugins="${plugins},pbxt"
573 else
574 myconf="${myconf} --without-plugin-pbxt"
575 fi
576 myconf="${myconf} $(use_with libevent)"
577 # This is not optional, without it several upstream testcases fail. 682 # This is not optional, without it several upstream testcases fail.
578 # Also strongly recommended by upstream. 683 # Also strongly recommended by upstream.
684 if [[ "${PV}" < "5.2.0" ]] ; then
579 myconf="${myconf} --with-maria-tmp-tables" 685 myconf="${myconf} --with-maria-tmp-tables"
686 plugins_sta="${plugins_sta} maria"
687 else
688 myconf="${myconf} --with-aria-tmp-tables"
689 plugins_sta="${plugins_sta} aria"
580 fi 690 fi
581 691
692 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
693 die "The ${P} package doesn't provide innobase nor xtradb"
694
695 for i in innobase xtradb ; do
696 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
697 done
698
699 myconf="${myconf} $(use_with libevent)"
700
701 if mysql_version_is_at_least "5.2" ; then
702 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
703 #for i in oqgraph sphinx ; do
704 for i in oqgraph ; do
705 use ${i} \
706 && plugins_dyn="${plugins_dyn} ${i}" \
707 || plugins_dis="${plugins_dis} ${i}"
708 done
709 fi
710 fi
711
712 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
713 use pbxt \
714 && plugins_dyn="${plugins_dyn} pbxt" \
715 || plugins_dis="${plugins_dis} pbxt"
716 fi
717
718 use static && \
719 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
720 plugins_dyn=""
721
722 einfo "Available plugins: ${plugins_avail}"
723 einfo "Dynamic plugins: ${plugins_dyn}"
724 einfo "Static plugins: ${plugins_sta}"
725 einfo "Disabled plugins: ${plugins_dis}"
726
727 # These are the static plugins
582 myconf="${myconf} --with-plugins=${plugins}" 728 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
729 # And the disabled ones
730 for i in ${plugins_dis} ; do
731 myconf="${myconf} --without-plugin-${i}"
732 done
583} 733}
584 734
585pbxt_src_configure() { 735pbxt_src_configure() {
586 mysql_init_vars 736 mysql_init_vars
587 737
588 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 738 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
589 739
590 einfo "Reconfiguring dir '${PWD}'" 740 einfo "Reconfiguring dir '${PWD}'"
591 AT_GNUCONF_UPDATE="yes" eautoreconf 741 eautoreconf
592 742
593 local myconf="" 743 local myconf=""
594 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)" 744 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
595 use debug && myconf="${myconf} --with-debug=full" 745 use debug && myconf="${myconf} --with-debug=full"
596 econf ${myconf} || die "Problem configuring PBXT storage engine" 746 econf ${myconf} || die "Problem configuring PBXT storage engine"
597} 747}
598 748
599pbxt_src_compile() { 749pbxt_src_compile() {
750
600 # Be backwards compatible for now 751 # Be backwards compatible for now
601 if [[ $EAPI != 2 ]]; then 752 if [[ $EAPI != 2 ]]; then
602 pbxt_src_configure 753 pbxt_src_configure
603 fi 754 fi
604 # TODO: is it safe/needed to use emake here ? 755 # TODO: is it safe/needed to use emake here ?
623# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv" 774# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
624# check for conflicting use flags 775# check for conflicting use flags
625# create new user and group for mysql 776# create new user and group for mysql
626# warn about deprecated features 777# warn about deprecated features
627mysql_pkg_setup() { 778mysql_pkg_setup() {
628 if hasq test ${FEATURES} ; then 779 if has test ${FEATURES} ; then
629 if ! use minimal ; then 780 if ! use minimal ; then
630 if [[ $UID -eq 0 ]]; then 781 if [[ $UID -eq 0 ]]; then
631 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 782 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
632 fi 783 fi
633 fi 784 fi
634 fi 785 fi
635 786
787 # bug 350844
788 case "${EAPI:-0}" in
789 0 | 1)
790 if use static && !built_with_use sys-libs/ncurses static-libs; then
791 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
792 fi
793 ;;
794 esac
795
636 # Check for USE flag problems in pkg_setup 796 # Check for USE flag problems in pkg_setup
637 if use static && use ssl ; then 797 if use static && use ssl ; then
638 eerror "MySQL does not support being built statically with SSL support enabled!"
639 die "MySQL does not support being built statically with SSL support enabled!" 798 M="MySQL does not support being built statically with SSL support enabled!"
799 eerror "${M}"
800 die "${M}"
801 fi
802
803 if mysql_version_is_at_least "5.1.51" \
804 && ! mysql_version_is_at_least "5.2" \
805 && use debug ; then
806 # Also in package.use.mask
807 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
640 fi 808 fi
641 809
642 if ! mysql_version_is_at_least "5.0" \ 810 if ! mysql_version_is_at_least "5.0" \
643 && use raid \ 811 && use raid \
644 && use static ; then 812 && use static ; then
646 eerror "with RAID support enabled." 814 eerror "with RAID support enabled."
647 die "USE flags 'raid' and 'static' conflict!" 815 die "USE flags 'raid' and 'static' conflict!"
648 fi 816 fi
649 817
650 if mysql_version_is_at_least "4.1.3" \ 818 if mysql_version_is_at_least "4.1.3" \
651 && ( use cluster || use extraengine ) \ 819 && ( use cluster || use extraengine || use embedded ) \
652 && use minimal ; then 820 && use minimal ; then
653 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
654 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 821 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
822 eerror "${M}"
823 die "${M}"
655 fi 824 fi
656 825
657 # Bug #290570 fun. Upstream made us need a fairly new GCC4.
658 if mysql_version_is_at_least "5.0.83" ; then 826 if mysql_version_is_at_least "5.1" \
827 && xtradb_patch_available \
828 && use xtradb \
829 && use embedded ; then
830 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
831 eerror "${M}"
832 die "${M}"
833 fi
834
835 # Bug #290570, 284946, 307251
836 # Upstream changes made us need a fairly new GCC4.
837 # But only for 5.0.8[3-6]!
838 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
659 GCC_VER=$(gcc-version) 839 GCC_VER=$(gcc-version)
660 case ${GCC_VER} in 840 case ${GCC_VER} in
661 2*|3*|4.0|4.1|4.2) die "Active GCC too old! Must have at least GCC4.3" ;; 841 2*|3*|4.0|4.1|4.2)
842 eerror "Some releases of MySQL required a very new GCC, and then"
843 eerror "later release relaxed that requirement again. Either pick a"
844 eerror "MySQL >=5.0.87, or use a newer GCC."
845 die "Active GCC too old!" ;;
662 esac 846 esac
663 fi 847 fi
664 848
665 # This should come after all of the die statements 849 # This should come after all of the die statements
666 enewgroup mysql 60 || die "problem adding 'mysql' group" 850 enewgroup mysql 60 || die "problem adding 'mysql' group"
716 mysql_mv_patches 900 mysql_mv_patches
717 # And apply 901 # And apply
718 epatch 902 epatch
719 903
720 # last -fPIC fixup, per bug #305873 904 # last -fPIC fixup, per bug #305873
721 i="${S}"/storage/innodb_plugin/plug.in 905 i="${S}"/storage/innodb_plugin/plug.in
722 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}" 906 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
723 907
724 # Additional checks, remove bundled zlib 908 # Additional checks, remove bundled zlib (Cluster needs this, for static
909 # memory management in zlib, leave available for Cluster)
910 if [[ "${PN}" != "mysql-cluster" ]] ; then
725 rm -f "${S}/zlib/"*.[ch] 911 rm -f "${S}/zlib/"*.[ch]
726 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 912 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
913 fi
727 rm -f "scripts/mysqlbug" 914 rm -f "scripts/mysqlbug"
728 915
729 # Make charsets install in the right place 916 # Make charsets install in the right place
730 find . -name 'Makefile.am' \ 917 find . -name 'Makefile.am' \
731 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 918 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
742 fi 929 fi
743 930
744 local rebuilddirlist d 931 local rebuilddirlist d
745 932
746 if xtradb_patch_available && use xtradb ; then 933 if xtradb_patch_available && use xtradb ; then
747 einfo "Replacing InnoDB with Percona XtraDB" 934 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
748 pushd "${S}"/storage 935 pushd "${S}"/storage >/dev/null
749 i="innobase" 936 i="innobase"
750 o="${WORKDIR}/storage-${i}.mysql-upstream" 937 o="${WORKDIR}/storage-${i}.mysql-upstream"
751 # Have we been here already? 938 # Have we been here already?
752 [ -d "${o}" ] && rm -f "${i}" 939 [ -d "${o}" ] && rm -f "${i}"
753 # Or maybe we haven't 940 # Or maybe we haven't
754 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 941 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
755 cp -ra "${WORKDIR}/${XTRADB_P}" "${i}" 942 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
756 popd 943 popd >/dev/null
944 fi
945
946 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
947 einfo "Adding storage engine: PBXT"
948 pushd "${S}"/storage >/dev/null
949 i='pbxt'
950 [ -d "${i}" ] && rm -rf "${i}"
951 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
952 popd >/dev/null
757 fi 953 fi
758 954
759 if mysql_version_is_at_least "5.1.12" ; then 955 if mysql_version_is_at_least "5.1.12" ; then
760 rebuilddirlist="." 956 rebuilddirlist="."
761 # This does not seem to be needed presently. robbat2 2010/02/23 957 # This does not seem to be needed presently. robbat2 2010/02/23
770 fi 966 fi
771 967
772 for d in ${rebuilddirlist} ; do 968 for d in ${rebuilddirlist} ; do
773 einfo "Reconfiguring dir '${d}'" 969 einfo "Reconfiguring dir '${d}'"
774 pushd "${d}" &>/dev/null 970 pushd "${d}" &>/dev/null
775 AT_GNUCONF_UPDATE="yes" eautoreconf 971 eautoreconf
776 popd &>/dev/null 972 popd &>/dev/null
777 done 973 done
778 974
779 if mysql_check_version_range "4.1 to 5.0.99.99" \ 975 if mysql_check_version_range "4.1 to 5.0.99.99" \
780 && use berkdb ; then 976 && use berkdb ; then
836 export CXXFLAGS 1032 export CXXFLAGS
837 1033
838 # bug #283926, with GCC4.4, this is required to get correct behavior. 1034 # bug #283926, with GCC4.4, this is required to get correct behavior.
839 append-flags -fno-strict-aliasing 1035 append-flags -fno-strict-aliasing
840 1036
1037 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1038 # causes a mis-compile.
1039 # Upstream bugs:
1040 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1041 # http://bugs.mysql.com/bug.php?id=45205
1042 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1043 append-flags -fno-omit-frame-pointer && \
1044 filter-flags -fomit-frame-pointer
1045
841 econf \ 1046 econf \
842 --libexecdir="/usr/sbin" \ 1047 --libexecdir="/usr/sbin" \
843 --sysconfdir="${MY_SYSCONFDIR}" \ 1048 --sysconfdir="${MY_SYSCONFDIR}" \
844 --localstatedir="${MY_LOCALSTATEDIR}" \ 1049 --localstatedir="${MY_LOCALSTATEDIR}" \
845 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 1050 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
848 --with-low-memory \ 1053 --with-low-memory \
849 --with-client-ldflags=-lstdc++ \ 1054 --with-client-ldflags=-lstdc++ \
850 --enable-thread-safe-client \ 1055 --enable-thread-safe-client \
851 --with-comment="Gentoo Linux ${PF}" \ 1056 --with-comment="Gentoo Linux ${PF}" \
852 --without-docs \ 1057 --without-docs \
1058 --with-LIBDIR="$(get_libdir)" \
853 ${myconf} || die "econf failed" 1059 ${myconf} || die "econf failed"
854 1060
855 # TODO: Move this before autoreconf !!! 1061 # TODO: Move this before autoreconf !!!
856 find . -type f -name Makefile -print0 \ 1062 find . -type f -name Makefile -print0 \
857 | xargs -0 -n100 sed -i \ 1063 | xargs -0 -n100 sed -i \
858 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 1064 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
859 1065
860 if [[ $EAPI == 2 ]]; then 1066 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
861 pbxt_patch_available && use pbxt && pbxt_src_configure 1067 pbxt_patch_available && use pbxt && pbxt_src_configure
862 fi 1068 fi
863} 1069}
864 1070
865# @FUNCTION: mysql_src_compile 1071# @FUNCTION: mysql_src_compile
872 0 | 1) mysql_src_configure ;; 1078 0 | 1) mysql_src_configure ;;
873 esac 1079 esac
874 1080
875 emake || die "emake failed" 1081 emake || die "emake failed"
876 1082
1083 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
877 pbxt_patch_available && use pbxt && pbxt_src_compile 1084 pbxt_patch_available && use pbxt && pbxt_src_compile
1085 fi
878} 1086}
879 1087
880# @FUNCTION: mysql_src_install 1088# @FUNCTION: mysql_src_install
881# @DESCRIPTION: 1089# @DESCRIPTION:
882# Install mysql. 1090# Install mysql.
888 DESTDIR="${D}" \ 1096 DESTDIR="${D}" \
889 benchdir_root="${MY_SHAREDSTATEDIR}" \ 1097 benchdir_root="${MY_SHAREDSTATEDIR}" \
890 testroot="${MY_SHAREDSTATEDIR}" \ 1098 testroot="${MY_SHAREDSTATEDIR}" \
891 || die "emake install failed" 1099 || die "emake install failed"
892 1100
1101 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
893 pbxt_patch_available && use pbxt && pbxt_src_install 1102 pbxt_patch_available && use pbxt && pbxt_src_install
1103 fi
894 1104
895 # Convenience links 1105 # Convenience links
896 einfo "Making Convenience links for mysqlcheck multi-call binary" 1106 einfo "Making Convenience links for mysqlcheck multi-call binary"
897 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 1107 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
898 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1108 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
922 if use !test ; then 1132 if use !test ; then
923 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test 1133 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
924 fi 1134 fi
925 1135
926 # Configuration stuff 1136 # Configuration stuff
927 if mysql_version_is_at_least "4.1" ; then 1137 case ${MYSQL_PV_MAJOR} in
928 mysql_mycnf_version="4.1"
929 else
930 mysql_mycnf_version="4.0" 1138 3*|4.0) mysql_mycnf_version="4.0" ;;
931 fi 1139 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
932 einfo "Building default my.cnf" 1140 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1141 esac
1142 einfo "Building default my.cnf (${mysql_mycnf_version})"
933 insinto "${MY_SYSCONFDIR}" 1143 insinto "${MY_SYSCONFDIR}"
934 doins scripts/mysqlaccess.conf 1144 doins scripts/mysqlaccess.conf
1145 mycnf_src="my.cnf-${mysql_mycnf_version}"
935 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1146 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
936 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1147 "${FILESDIR}/${mycnf_src}" \
937 > "${TMPDIR}/my.cnf.ok" 1148 > "${TMPDIR}/my.cnf.ok"
938 if mysql_version_is_at_least "4.1" && use latin1 ; then 1149 if use latin1 ; then
939 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1150 sed -i \
1151 -e "/character-set/s|utf8|latin1|g" \
1152 "${TMPDIR}/my.cnf.ok"
940 fi 1153 fi
941 newins "${TMPDIR}/my.cnf.ok" my.cnf 1154 newins "${TMPDIR}/my.cnf.ok" my.cnf
942 1155
943 # Minimal builds don't have the MySQL server 1156 # Minimal builds don't have the MySQL server
944 if ! use minimal ; then 1157 if ! use minimal ; then
959 done 1172 done
960 fi 1173 fi
961 1174
962 # Docs 1175 # Docs
963 einfo "Installing docs" 1176 einfo "Installing docs"
964 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1177 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1178 [[ -f "$i" ]] && dodoc "$i"
1179 done
965 doinfo "${S}"/Docs/mysql.info 1180 doinfo "${S}"/Docs/mysql.info
966 1181
967 # Minimal builds don't have the MySQL server 1182 # Minimal builds don't have the MySQL server
968 if ! use minimal ; then 1183 if ! use minimal ; then
969 einfo "Including support files and sample configurations" 1184 einfo "Including support files and sample configurations"
1035 1250
1036 einfo 1251 einfo
1037 elog "You might want to run:" 1252 elog "You might want to run:"
1038 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1253 elog "\"emerge --config =${CATEGORY}/${PF}\""
1039 elog "if this is a new install." 1254 elog "if this is a new install."
1255 einfo
1256
1257 einfo
1258 elog "If you are upgrading major versions, you should run the"
1259 elog "mysql_upgrade tool."
1040 einfo 1260 einfo
1041 fi 1261 fi
1042 1262
1043 if pbxt_available && use pbxt ; then 1263 if pbxt_available && use pbxt ; then
1044 # TODO: explain it better 1264 # TODO: explain it better
1099 fi 1319 fi
1100 fi 1320 fi
1101 1321
1102 local pwd1="a" 1322 local pwd1="a"
1103 local pwd2="b" 1323 local pwd2="b"
1104 local maxtry=5 1324 local maxtry=15
1325
1326 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1327 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1328 fi
1105 1329
1106 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1330 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
1107 ewarn "You have already a MySQL database in place." 1331 ewarn "You have already a MySQL database in place."
1108 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1332 ewarn "(${ROOT}/${MY_DATADIR}/*)"
1109 ewarn "Please rename or delete it if you wish to replace it." 1333 ewarn "Please rename or delete it if you wish to replace it."
1112 1336
1113 # Bug #213475 - MySQL _will_ object strenously if your machine is named 1337 # Bug #213475 - MySQL _will_ object strenously if your machine is named
1114 # localhost. Also causes weird failures. 1338 # localhost. Also causes weird failures.
1115 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1339 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
1116 1340
1117 einfo "Creating the mysql database and setting proper" 1341 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1118 einfo "permissions on it ..."
1119 1342
1120 einfo "Insert a password for the mysql 'root' user" 1343 einfo "Please provide a password for the mysql 'root' user now, in the"
1344 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
1121 ewarn "Avoid [\"'\\_%] characters in the password" 1345 ewarn "Avoid [\"'\\_%] characters in the password"
1122 read -rsp " >" pwd1 ; echo 1346 read -rsp " >" pwd1 ; echo
1123 1347
1124 einfo "Retype the password" 1348 einfo "Retype the password"
1125 read -rsp " >" pwd2 ; echo 1349 read -rsp " >" pwd2 ; echo
1126 1350
1127 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1351 if [[ "x$pwd1" != "x$pwd2" ]] ; then
1128 die "Passwords are not the same" 1352 die "Passwords are not the same"
1353 fi
1354 MYSQL_ROOT_PASSWORD="${pwd1}"
1355 unset pwd1 pwd2
1129 fi 1356 fi
1130 1357
1131 local options="" 1358 local options=""
1132 local sqltmp="$(emktemp)" 1359 local sqltmp="$(emktemp)"
1133 1360
1147 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1374 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
1148 || die "MySQL databases not installed" 1375 || die "MySQL databases not installed"
1149 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null 1376 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
1150 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null 1377 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
1151 1378
1379 # Figure out which options we need to disable to do the setup
1380 helpfile="${TMPDIR}/mysqld-help"
1381 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1382 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1383 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1384 ndbcluster \
1385 ; do
1386 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1387 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1388 done
1389 # But some options changed names
1390 egrep -sq external-locking "${helpfile}" && \
1391 options="${options/skip-locking/skip-external-locking}"
1392
1152 if mysql_version_is_at_least "4.1.3" ; then 1393 if mysql_version_is_at_least "4.1.3" ; then
1153 options="--skip-ndbcluster"
1154
1155 # Filling timezones, see 1394 # Filling timezones, see
1156 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1395 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
1157 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1396 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
1158 1397
1159 if [[ -r "${help_tables}" ]] ; then 1398 if [[ -r "${help_tables}" ]] ; then
1160 cat "${help_tables}" >> "${sqltmp}" 1399 cat "${help_tables}" >> "${sqltmp}"
1161 fi 1400 fi
1162 fi 1401 fi
1402
1403 einfo "Creating the mysql database and setting proper"
1404 einfo "permissions on it ..."
1163 1405
1164 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1406 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1165 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1407 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
1166 local mysqld="${ROOT}/usr/sbin/mysqld \ 1408 local mysqld="${ROOT}/usr/sbin/mysqld \
1167 ${options} \ 1409 ${options} \
1168 --user=mysql \ 1410 --user=mysql \
1169 --skip-grant-tables \
1170 --basedir=${ROOT}/usr \ 1411 --basedir=${ROOT}/usr \
1171 --datadir=${ROOT}/${MY_DATADIR} \ 1412 --datadir=${ROOT}/${MY_DATADIR} \
1172 --skip-innodb \
1173 --skip-bdb \
1174 --skip-networking \
1175 --max_allowed_packet=8M \ 1413 --max_allowed_packet=8M \
1176 --net_buffer_length=16K \ 1414 --net_buffer_length=16K \
1415 --default-storage-engine=MyISAM \
1177 --socket=${socket} \ 1416 --socket=${socket} \
1178 --pid-file=${pidfile}" 1417 --pid-file=${pidfile}"
1418 #einfo "About to start mysqld: ${mysqld}"
1419 ebegin "Starting mysqld"
1179 ${mysqld} & 1420 ${mysqld} &
1421 rc=$?
1180 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1422 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
1181 maxtry=$((${maxtry}-1)) 1423 maxtry=$((${maxtry}-1))
1182 echo -n "." 1424 echo -n "."
1183 sleep 1 1425 sleep 1
1184 done 1426 done
1427 eend $rc
1185 1428
1429 if ! [[ -S "${socket}" ]]; then
1430 die "Completely failed to start up mysqld with: ${mysqld}"
1431 fi
1432
1433 ebegin "Setting root password"
1186 # Do this from memory, as we don't want clear text passwords in temp files 1434 # Do this from memory, as we don't want clear text passwords in temp files
1187 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1435 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
1188 "${ROOT}/usr/bin/mysql" \ 1436 "${ROOT}/usr/bin/mysql" \
1189 --socket=${socket} \ 1437 --socket=${socket} \
1190 -hlocalhost \ 1438 -hlocalhost \
1191 -e "${sql}" 1439 -e "${sql}"
1440 eend $?
1192 1441
1193 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1442 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
1194
1195 "${ROOT}/usr/bin/mysql" \ 1443 "${ROOT}/usr/bin/mysql" \
1196 --socket=${socket} \ 1444 --socket=${socket} \
1197 -hlocalhost \ 1445 -hlocalhost \
1198 -uroot \ 1446 -uroot \
1199 -p"${pwd1}" \ 1447 -p"${MYSQL_ROOT_PASSWORD}" \
1200 mysql < "${sqltmp}" 1448 mysql < "${sqltmp}"
1449 rc=$?
1450 eend $?
1451 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
1201 1452
1202 # Stop the server and cleanup 1453 # Stop the server and cleanup
1454 einfo "Stopping the server ..."
1203 kill $(< "${pidfile}" ) 1455 kill $(< "${pidfile}" )
1204 rm -f "${sqltmp}" 1456 rm -f "${sqltmp}"
1205 einfo "Stopping the server ..."
1206 wait %1 1457 wait %1
1207 einfo "Done" 1458 einfo "Done"
1208} 1459}
1209 1460
1210# @FUNCTION: mysql_pkg_postrm 1461# @FUNCTION: mysql_pkg_postrm

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.163

  ViewVC Help
Powered by ViewVC 1.1.20